require 'net/http'
require 'uri'
require 'json'

class BitcoinRPC
  def initialize(service_url)
    @uri = URI.parse(service_url)
  end

  def method_missing(name, *args)


    begin
      post_body = { 'method' => name, 'params' => args, 'id' => 'jsonrpc' }.to_json
      JSON.parse( http_post_request(post_body) )
      resp = JSON.parse( http_post_request(post_body) )
      raise JSONRPCError, resp['error'] if resp['error']
      resp['result']
    rescue Exception => err
      puts "Error: #{err}"
    end



  end

  def http_post_request(post_body)
    http    = Net::HTTP.new(@uri.host, @uri.port)
    request = Net::HTTP::Post.new(@uri.request_uri)
    request.basic_auth @uri.user, @uri.password
    request.content_type = 'application/json'
    request.body = post_body
    http.request(request).body
  rescue
    @uri.host
    message(@uri.host)
  end

  class JSONRPCError < RuntimeError; end
end
